<template>
    <div>
        <v-text-field class="seachbox" ref="searchbox" solo append-icon="mdi-map-marker"></v-text-field>
        <div ref="map" style="width: 100%; height: 250px;"></div>
    </div>
</template>

<script lang="ts">
import { Component, Model, Vue } from 'vue-property-decorator';
import { Loader, LoaderOptions } from 'google-maps';
import { Location as LocationModel } from '@/model/delivery/Location';

interface TextField {
    $refs: {
        input: HTMLInputElement;
    };
    $el: HTMLLIElement;
}

@Component
export default class Map extends Vue {
    @Model('change', Object) readonly location!: LocationModel;
    marker = {};

    initMap(): void {
        const options: LoaderOptions = { libraries: ['places'] };
        const loader = new Loader(process.env.VUE_APP_FB_API_KEY, options);
        loader.load().then(google => {
            const map = new google.maps.Map(this.$refs.map as Element, {
                center: { lat: this.location.lat, lng: this.location.lng },
                zoom: 8,
                mapTypeId: 'roadmap'
            });
            const pin = new google.maps.Marker({
                position: { lat: this.location.lat, lng: this.location.lng },
                map
            });
            map.addListener('click', evt => {
                pin.setPosition(evt.latLng);
                this.marker = { lat: evt.latLng.lat(), lng: evt.latLng.lng() };
                this.$emit('change', this.marker);
            });
            const input = ((this.$refs.searchbox as unknown) as TextField).$refs.input as HTMLInputElement;
            const searchBox = new google.maps.places.SearchBox(input);
            map.controls[google.maps.ControlPosition.BOTTOM_CENTER].push(
                ((this.$refs.searchbox as unknown) as TextField).$el
            );
            map.addListener('bounds_changed', () => {
                searchBox.setBounds(map.getBounds() as google.maps.LatLngBounds);
            });
            searchBox.addListener('places_changed', () => {
                const places = searchBox.getPlaces();

                if (places.length == 0) {
                    return;
                }

                const bounds = new google.maps.LatLngBounds();
                places.forEach(place => {
                    if (!place.geometry) {
                        return;
                    }
                    pin.setPosition(place.geometry.location);
                    this.marker = { lat: place.geometry.location.lat(), lng: place.geometry.location.lng() };
                    this.$emit('change', this.marker);
                    if (place.geometry.viewport) {
                        bounds.union(place.geometry.viewport);
                    } else {
                        bounds.extend(place.geometry.location);
                    }
                });
                map.fitBounds(bounds);
            });
        });
    }

    created() {
        this.initMap();
    }
}
</script>
<style type="text/css">
.seachbox {
    margin-top: 10px !important;
}
</style>
